#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>           /* For O_* constants */
#include <sys/stat.h>        /* For mode constants */
#include <mqueue.h>
#include "mq.h"

int main(void)
{
    mqd_t qd;
    struct mq_attr attr;
    attr.mq_flags = 0;
    attr.mq_maxmsg = MAX_MESSAGES;
    attr.mq_msgsize = MAX_MSG_SIZE;
    attr.mq_curmsgs = 0;

    if ((qd = mq_open(SERVER_QUEUE_NAME, O_RDONLY | O_CREAT, QUEUE_PERMISSIONS, &attr)) == -1) {
        perror ("Server: mq_open (server)");
        exit (1);
    }

    char buf[MSG_BUFFER_SIZE];
    while (strncmp("EXIT", buf, 4U) != 0)
    {
        memset(buf, 0, MSG_BUFFER_SIZE);
        puts("Waiting for message...");
        mq_receive(qd, buf, sizeof(buf), NULL);
        printf("Received message: %s\n", buf);
    }

    mq_close(qd);
    mq_unlink(SERVER_QUEUE_NAME);
    return 0;
}
