#include <err.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>           /* For O_* constants */
#include <sys/stat.h>        /* For mode constants */
#include <mqueue.h>
#include "mq.h"

int main(int argc, char **argv)
{
    mqd_t qd;

    if (argc != 2)
    {
        errx(EXIT_FAILURE, "Usage: %s <message>\n", argv[0]);
    }

    if ((qd = mq_open(SERVER_QUEUE_NAME, O_WRONLY)) == -1)
    {
        perror ("Client: mq_open (server)");
        exit (1);
    }

    // send message to server
    if (mq_send (qd, argv[1], strlen(argv[1]) + 1, 0) == -1) {
        perror ("Client: Not able to send message to server");
        exit(1);
    }
    mq_close(qd);
    return 0;
}
