#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>
#include <sys/mman.h>
#include <sys/stat.h>        /* For mode constants */
#include <fcntl.h>
#include <unistd.h>
#include "shared.h"

int main(int argc, char *argv[])
{
	printf("create.c\n\n");

    if (argc != 2)
    {
        fprintf(stderr, "Usage: %s <SHM name>\n", argv[0]);
        return EXIT_FAILURE;
    }
    int shmFd = shm_open(argv[1], O_CREAT | O_RDWR, S_IRUSR | S_IWUSR);
    if (shmFd < 0)
    {
        perror("shm_open");
        return EXIT_FAILURE;
    }

    if (ftruncate(shmFd, sizeof(struct shared)) != 0)
    {
        perror("ftruncate");
        return EXIT_FAILURE;
    }


	return EXIT_SUCCESS;
}
