#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>
#include <sys/mman.h>
#include <sys/stat.h>        /* For mode constants */
#include <fcntl.h>
#include "shared.h"

int main(int argc, char *argv[])
{
    if (argc != 2)
    {
        fprintf(stderr, "Usage: %s <SHM name>\n", argv[0]);
        return EXIT_FAILURE;
    }
    int shmFd = shm_open(argv[1], O_RDONLY, S_IRUSR | S_IWUSR);
    if (shmFd < 0)
    {
        perror("shm_open");
        return EXIT_FAILURE;
    }
    struct shared *mybuffer;
    mybuffer = mmap(NULL, sizeof(struct shared), PROT_READ, MAP_SHARED, shmFd, 0);

    printf("Read from shared memory:\n");
    printf("\tPID   : %i\n", mybuffer->pid);
    printf("\ti     : %i\n", mybuffer->i);
    printf("\tsymbol: ");
    for (unsigned i = 0u; i < mybuffer->length; i++)
    {
        printf("%c", mybuffer->name[i]);
    }
    puts("");

	return EXIT_SUCCESS;
}
