#include <stdio.h>
#include <stdlib.h>
#include "msg.h"
#include "mbox.h"
#include "thread.h"

static char stack1[THREAD_STACKSIZE_MAIN];
static char stack2[THREAD_STACKSIZE_MAIN];

static msg_t queue[16U];
static mbox_t mbox;

volatile unsigned done;

static void *_thread(void *arg)
{
    (void) arg;

    msg_t m;
    mbox_get(&mbox, &m);
    printf("THREAD %i received message with content %i\n", thread_getpid(), m.content.value);
    ++done;

    return NULL;
}

static void _send(mbox_t *mbox, msg_t *m)
{
    printf("SENDER: Sending message\n");
    mbox_put(mbox, m);
}

int main(void)
{
    mbox_init(&mbox, queue, 16U);
    thread_create(stack1,
                  sizeof(stack1),
                  THREAD_PRIORITY_MAIN - 1,
                  THREAD_CREATE_STACKTEST,
                  _thread,
                  NULL,
                  "second_thread");

    thread_create(stack2,
                  sizeof(stack2),
                  THREAD_PRIORITY_MAIN - 1,
                  THREAD_CREATE_STACKTEST,
                  _thread,
                  NULL,
                  "third thread");

    msg_t m;
    m.content.value = 42U;
    _send(&mbox, &m);
    m.content.value = 23U;
    _send(&mbox, &m);
    while(done < 2) {};
    return 1;
}
