#include <stdio.h>
#include <stdlib.h>
#include "msg.h"
#include "thread.h"
#include "ztimer.h"

static char stack[THREAD_STACKSIZE_MAIN];

static void *_thread(void *arg)
{
    (void) arg;

    puts("THREAD is going to sleep first");
    ztimer_sleep(ZTIMER_SEC, 3U);
    msg_t m;
    msg_receive(&m);
    printf("THREAD %i received message with content %i\n", thread_getpid(), m.content.value);

    return NULL;
}

int main(void)
{
    kernel_pid_t threadpid = thread_create(stack,
                  sizeof(stack),
                  THREAD_PRIORITY_MAIN - 1,
                  THREAD_CREATE_STACKTEST,
                  _thread,
                  NULL,
                  "second_thread");

    msg_t m;
    m.content.value = 42U;
    puts("SENDER trying to send blocking");
    msg_send(&m, threadpid);
    puts("SENDER is done");

    puts("SENDER trying to send non-blocking");
    int ret = msg_try_send(&m, threadpid);
    printf("SENDER is done, msg_try_send returned %i\n", ret);
    return 1;
}
