#include <stdio.h>
#include <stdlib.h>
#include "thread.h"
#include "xtimer.h"
#include "shell.h"

static char stack[THREAD_STACKSIZE_MAIN];

volatile unsigned done;

static void *_thread(void *arg)
{
    (void) arg;

    thread_flags_t flags;

    puts("RECEIVER:: waiting for 0x1...");
    flags = thread_flags_wait_any(0x1);
    printf("RECEIVER:: received flags: 0x%04x\n", (unsigned)flags & 0xFFFF);

    puts("RECEIVER:: waiting for 0x1 || 0x64...");
    flags = thread_flags_wait_any(0x1 | 0x64);
    printf("RECEIVER:: received flags: 0x%04x\n", (unsigned)flags & 0xFFFF);

    puts("RECEIVER:: waiting for 0x2 && 0x4...");
    flags = thread_flags_wait_all(0x2 | 0x4);
    printf("RECEIVER:: received flags: 0x%04x\n", (unsigned)flags & 0xFFFF);

    puts("RECEIVER:: waiting for any flag, one by one");
    flags = thread_flags_wait_one(0xFFFF);
    printf("RECEIVER:: received flags: 0x%04x\n", (unsigned)flags & 0xFFFF);

    puts("RECEIVER:: waiting for any flag, one by one");
    flags = thread_flags_wait_one(0xFFFF);
    printf("RECEIVER:: received flags: 0x%04x\n", (unsigned)flags & 0xFFFF);

    done = 1;

    return NULL;
}

static void _set(thread_t *thread, thread_flags_t flags)
{
    printf("SENDER: setting flag 0x%04x\n", (unsigned)flags & 0xFFFF);
    thread_flags_set(thread, flags);
}

int main(void)
{
    kernel_pid_t pid = thread_create(stack,
                  sizeof(stack),
                  THREAD_PRIORITY_MAIN - 1,
                  THREAD_CREATE_STACKTEST,
                  _thread,
                  NULL,
                  "second_thread");

    thread_t *thread = (thread_t*) thread_get(pid);
    _set(thread, 0x1);
    _set(thread, 0x64);
    _set(thread, 0x1);
    //_set(thread, 0x8);
    _set(thread, 0x2);
    _set(thread, 0x4);

    char line_buf[SHELL_DEFAULT_BUFSIZE];
    shell_run(NULL, line_buf, SHELL_DEFAULT_BUFSIZE);

    return 1;
}
